{$i+}
uses Objects,DOS;

const IndexName = 'INDEX.HTM';
      MaxDir = 32;
      tSep = ':';
      dSep = '.';

var Root,RootHTML:string;
    XLAT:array [0..255] of char;
    FHome:PathStr; FName:NameStr; FExt:ExtStr;

type
  PIndex = ^TIndex;
  TIndex = object(TObject)
      FB,FH:text;
      Prev,Dir:PString;
      R:SearchRec;
      Res,isDesc:boolean;
      DD:PIndex;
      s:string;
      Scanned:boolean;
      L:TCollection;
      Cur:longint;
    constructor init(const APrev,ADir:string);
    function Go:boolean;
    destructor done; virtual;
    procedure CopyFile(const Name:string);
    procedure CreateNdx;
    procedure CloseNdx;
    procedure CloseLine;
    procedure WriteDesc(const ss:string);
    procedure WrNdx(const Path,Lnk,Desc:string; RData:boolean);
    procedure WrNdxR;
    procedure FindFile(Name:string);
    procedure FindFirst_;
    procedure FindNext_;
    procedure FindClose_;
      { - File info. In DOS - FindFirst, in other - open.}
  end;

  PSearch = ^TSearch;
  TSearch = object(TObject)
      R:SearchRec;
    constructor init(var AR:SearchRec);
  end;

constructor TSearch.init;
begin
     inherited init;
     R:=AR;
end;

constructor TIndex.init;
begin
     inherited init;
     Prev:=NewStr(APrev);
     Dir:=NewStr(ADir);
end;

destructor TIndex.Done;
begin
     DisposeStr(Prev);
     DisposeStr(Dir);
     FindClose_;
end;

procedure TIndex.CopyFile;
var f:text;
    ss:string;
    i:integer;
begin
     assign(f,Dir^+name); {$i-}reset(f); i:=ioresult; {$i+}
     if i<>0 then begin
        assign(f,FHome+name);
        reset(f);
     end;
     while not eof(f) do begin
           readln(f,ss);
           writeln(fh,ss);
     end;
     close(f);
end;

function ZStr(p:PString):boolean;
begin
     if p=NIL then ZStr:=True else ZStr:=p^='';
end;

procedure TIndex.CreateNdx;
var m:integer;
begin
     if Res then exit;
     Res:=True;
     m:=FileMode;
     FileMode:=2;
     assign(fh,Dir^+IndexName); rewrite(fh);
     FileMode:=m;
     CopyFile('HEADER.HTM');
     writeln(fh,'<TABLE valign="top" cellspacing=0><TR><TH>file</TH><TH>size</TH><TH>D'+dSep+'M'+dSep+
       'Y</TH><TH>time</TH><TH>description</TH></TR>');
     if not ZStr(Prev) then WrNdx(Prev^,'[..]','Up',False);
end;

type str10=string[10];
function ValSz(i,n:word):str10;
var s:str10;
begin
     str(i:n,s);
     for i:=1 to length(s) do if s[i]=' ' then s[i]:='0';
{     while length(s)<n do s:=s+}
     ValSz:=s;
end;

procedure TIndex.WrNdx;
var i:integer;
    s1:string;
    d:DateTime;
begin
     CreateNdx;
     CloseLine;
     s1:=Path;
     if pos(Root,s1)=1 then begin
        delete(s1,1,length(Root));
        s1:=RootHTML+s1;
     end;
     for i:=1 to length(s1) do if s1[i]='\' then s1[i]:='/';
     write(fh,'<tr><td><A HREF="',s1,'">',Lnk,'</A></td><td>');
     if RData then begin
        if (R.Attr and Directory)<>0 then write(fh,'SUB-DIR</td>')
        else write(fh,R.Size,'</td>');
        UnpackTime(R.Time,D);
        write(fh,'<td>',ValSz(D.Day,2),dSep,ValSz(D.Month,2),dSep,D.Year,
           '</td><td>',ValSz(D.Hour,2),tSep,ValSz(D.Min,2),'</td>');
     end else write(fh,'<td></td><td></td><td></td>');
     write(fh,'<td>',Desc);
     isDesc:=True;
end;

procedure TIndex.WrNdxR;
begin
     if (R.Attr and Directory)=0 then WrNdx({Dir^+}R.Name,R.Name,'',True)
     else begin
          WrNdx({Dir^+}R.Name,'['+R.Name+']','',True);
     end;
end;

const Cnt:word = 32;

function TIndex.Go;
label EX;
var i:integer;
begin
     Res:=False;
     Go:=False;
     if ZStr(Dir) then exit;
     dec(Cnt); if Cnt=0 then exit;
     assign(fb,Dir^+'files.bbs'); {$i-}reset(fb); i:=ioresult;{$i+}
     if i<>0 then begin
        FindFirst_;
        while DosError=0 do begin
              if ((R.Attr and Directory)<>0) and (R.Name<>'..') and (R.Name<>'.') then begin
                 DD:=new(PIndex,init(Dir^,Dir^+R.Name+'\'));
                 if DD^.Go then WrNdxR;
                 DD^.Free;
              end;
              FindNext_;
        end;
        goto EX;
     end;
     while not eof(fb) do begin
           readln(fb,s);
           for i:=1 to length(s) do s[i]:=XLAT[byte(s[i])];
           if (copy(s,1,1)=' ') or (copy(s,1,1)=#9) then begin
              if Res then WriteDesc(s);
           end else if s<>'' then begin
               CloseLine;
               i:=pos(' ',s); if i=0 then i:=254;
               FindFile(copy(s,1,i-1));
               if DosError=0 then begin
                  if (R.Attr and Directory)=0 then WrNdxR
                  else begin
                      DD:=new(PIndex,init(Dir^,Dir^+R.Name+'\'));
                      if DD^.Go then WrNdxR;
                      DD^.Free;
                  end;
                  WriteDesc(copy(s,i+1,255));
               end else begin
                   DD:=new(PIndex,init(Dir^,copy(s,1,i-1)+'\'));
                   if DD^.Go then WrNdx(copy(s,1,i-1),copy(s,1,i-1),'',False);
                   DD^.Free;
               end;

           end;
           DosError:=0;
     end;
     close(fb);
EX:
     inc(Cnt);
     if Res then begin
        writeln(Dir^);
        CloseNdx;
     end;
     Go:=Res;
     DosError:=0;
end;

function Up(s:string):string;
var i:integer;
begin
     for i:=1 to length(s) do s[i]:=UpCase(s[i]);
     Up:=s;
end;

procedure TIndex.FindFile;
begin
     Name:=Up(Name);
     FindFirst_;
     while DosError=0 do begin
           if Name=Up(R.Name) then exit;
           FindNext_;
     end;
end;

procedure TIndex.FindFirst_;
begin
     if not Scanned then begin
        L.Init(10,10);
        FindFirst(Dir^+'*.*',Directory,R);
        while DosError=0 do begin
              L.Insert(new(PSearch,init(R)));
              FindNext(R);
        end;
        Scanned:=True;
     end;
     Cur:=0;
     FindNext_;
end;

procedure TIndex.FindNext_;
begin
     if Cur<L.Count then begin
        R:=PSearch(L.At(Cur))^.R;
        DosError:=0;
     end else DosError:=2;
     inc(Cur);
end;

procedure TIndex.FindClose_;
begin
     if Scanned then L.Done;
     Scanned:=False;
end;


procedure TIndex.CloseNdx;
begin
     CloseLine;
     write(fh,'</TABLE>');
     CopyFile('FOOTER.HTM');
     close(fh);
end;

procedure TIndex.CloseLine;
begin
     if isDesc then begin
        write(fh,'</td></tr>');
        isDesc:=False;
     end;
end;

procedure TIndex.WriteDesc;
begin
     if isDesc then writeln(fh,ss);
end;


var c:char;
    DD:TIndex;
    ff:file;

BEGIN
     writeln('BBS2HTML v1.0 (c) mahatma E-Mail: mahatma_d@usa.net AKA 2:450/83.49@fidonet.org');
     if paramcount=0 then begin
        writeln('Usage: BBS2HTML <ROOT_DIR> [<ROOT_HTML_DIR>]');
        halt(1);
     end;
     Root:=paramstr(1);
     RootHTML:=paramstr(2);
     c:=Root[length(Root)];
     if (Root<>'') and not (Root[length(Root)] in [':','\','/']) then Root:=Root+'\';
     FSplit(paramstr(0),FHome,FName,FExt);
     FileMode:=0;
     assign(ff,FHome+'BBS2HTML.TAB'); reset(ff,1); blockread(ff,XLAT,256); close(ff);
     DD.Init('',Root);
     DD.Go;
     DD.Done;
END.

